package ru.landgrafhomyak.db.sql_skeleton_0.api.misc

import kotlin.jvm.JvmField
import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.RowId
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.Table

@Suppress("ClassName", "RemoveRedundantQualifierName")
public interface DatabaseType<@Suppress("unused") RT> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getName")
	public val name: String

	public abstract class _VirtualType<RT, wRT, wDT : DatabaseType<wRT>>(
		@JvmField
		public val wraps: wDT,
		@JvmField
		public val allowValuesCaching: Boolean = true
	) : DatabaseType<RT> {
		@Suppress("FunctionName")
		public abstract fun _unwrap(w: wRT): RT

		@Suppress("FunctionName")
		public abstract fun _wrap(w: RT): wRT

		@Suppress("FunctionName")
		public abstract fun _equals(l: RT, r: RT): Boolean

		@Suppress("FunctionName")
		public abstract fun _compare(l: RT, r: RT): Int
	}

	public interface Nullable<RT : Any, @Suppress("unused") DT : DatabaseType<RT>> : DatabaseType<RT?>

	public interface ROW_ID<ttUE : Any> : DatabaseType<RowId<ttUE>>

	public interface BOOLEAN : DatabaseType<Boolean>

	@OptIn(ExperimentalUnsignedTypes::class)
	public interface BINARY_DATA : DatabaseType<UByteArray> {
		@Suppress("INAPPLICABLE_JVM_NAME")
		@get:JvmName("getMaxSizeOrNull")
		public val maxSizeOrNull: UInt?


		@Suppress("INAPPLICABLE_JVM_NAME")
		@get:JvmName("isFixedSize")
		public val isFixedSize: Boolean
	}

	public interface Provider {
		public fun <tUE : Any> ROW_ID(table: Table<tUE, *>): DatabaseType.ROW_ID<tUE>

		@Suppress("INAPPLICABLE_JVM_NAME", "PropertyName")
		@get:JvmName("BOOLEAN")
		public val BOOLEAN: BOOLEAN

		@Suppress("INAPPLICABLE_JVM_NAME", "PropertyName")
		@get:JvmName("BINARY_DATA")
		public val BINARY_DATA: BINARY_DATA

		public fun BINARY_DATA(size: UInt, isFixedSize: Boolean): BINARY_DATA

		public fun <RT : Any, DT : DatabaseType<RT>> nullableOf(notNull: DT): Nullable<RT, DT>
	}
}
