package ru.landgrafhomyak.db.sql_skeleton_0.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.queries._Query
import ru.landgrafhomyak.db.sql_skeleton_0.api.runtime.Executor
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.Table
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.TableConstructor


public interface Module<mUE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: mUE

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getVersionKey")
	public val versionKey: String

	public fun <R : Any> createQuery(c: _Query.Constructor<R>): R

	public fun <tUE : Any> createSessionScopeTemporaryTable(name: String, initializer: TableConstructor<tUE>): Table<tUE, Nothing>

	public fun <tUE : Any> createTransactionScopeTemporaryTable(name: String, initializer: TableConstructor<tUE>): Table<tUE, Nothing>

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("executor")
	public val executor: Executor
}