package ru.landgrafhomyak.db.sql_skeleton_0.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.runtime.Transaction

public interface ModuleTemplate<@Suppress("unused") mUE : Any> {
	public interface VersionsInitializer<UE : Any> {
		public fun createModuleTemplates(context: Scope): UE

		public interface Scope {
			public fun <nmUE : Any> createTemplate(
				constructor: ModuleConstructor<nmUE>,
			): ModuleTemplate<nmUE>

			public fun <omUE : Any, nmUE : Any> upgradeTemplate(
				oldModule: ModuleTemplate<omUE>,
				upgrade: ModuleUpgrade<omUE, nmUE>,
			): ModuleTemplate<nmUE>

			public fun <omUE : Any, nmUE : Any> upgradeTemplateAndMerge(
				oldModule: ModuleTemplate<omUE>,
				upgrade: ModuleUpgrade<omUE, nmUE>,
				mergeTo: ModuleTemplate<nmUE>
			): ModuleTemplate<nmUE>
		}
	}

	public interface ModuleConstructor<mUE : Any> {
		@Suppress("INAPPLICABLE_JVM_NAME")
		@get:JvmName("versionKey")
		public val versionKey: String

		public fun createSchema(context: CreateModuleScope): mUE

		public suspend fun initData(ext: mUE, transaction: Transaction) {}
	}

	public interface ModuleUpgrade<omUE : Any, nmUE : Any> {
		@Suppress("INAPPLICABLE_JVM_NAME")
		@get:JvmName("versionKey")
		public val versionKey: String

		public fun upgradeSchema(context: UpgradeModuleScope<omUE>): nmUE

		public suspend fun upgradeData(ext: nmUE, transaction: Transaction) {}
	}

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getVersionKey")
	public val versionKey: String
}