package ru.landgrafhomyak.db.sql_skeleton_0.api.runtime

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.misc.Column

public interface OutputRow<qUE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: qUE

	public operator fun <RuntimeType> get(c: Column<RuntimeType, *, qUE>): RuntimeType

	public operator fun get(c: Column<Byte, *, qUE>): Byte = this.get<Byte>(c)
	public operator fun get(c: Column<UByte, *, qUE>): UByte = this.get<UByte>(c)
	public operator fun get(c: Column<Short, *, qUE>): Short = this.get<Short>(c)
	public operator fun get(c: Column<UShort, *, qUE>): UShort = this.get<UShort>(c)
	public operator fun get(c: Column<Int, *, qUE>): Int = this.get<Int>(c)
	public operator fun get(c: Column<UInt, *, qUE>): UInt = this.get<UInt>(c)
	public operator fun get(c: Column<Long, *, qUE>): Long = this.get<Long>(c)
	public operator fun get(c: Column<ULong, *, qUE>): ULong = this.get<ULong>(c)
	public operator fun get(c: Column<Char, *, qUE>): Char = this.get<Char>(c)
	public operator fun get(c: Column<Boolean, *, qUE>): Boolean = this.get<Boolean>(c)

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Iterator<QueryUserExtension : Any, out Next> : OutputRow<QueryUserExtension> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _next(): Boolean

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _abort()

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _finish(): Next
	}
}